import greenfoot.*;
import java.awt.Color;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class ForcefieldBar extends Actor
{
    int r = 0;
    int g = 255;
    int b = 0;
    int alpha = 255;
    int imageFill = 0;
    
    public ForcefieldBar(int rotation)
    {
        setRotation(rotation);
    }

    public void act() 
    {
        setMyImage();
    } 

    public void setMyImage()
    {
        Space mySpace = (Space) getWorld();
        Forcefield forcefield = mySpace.getForcefield();
        Starship Endeavour = mySpace.getStarship();
        if (Endeavour.getHealth() < 0)
        {
            getWorld().removeObject(this);
        }
        int imageX = 200;
        int imageY = 30;
        GreenfootImage img = new GreenfootImage(imageX, imageY);
        img.setColor(MyColor());
        if (forcefield.getAlpha() == 0)
        {
            imageFill = (forcefield.getRegenerate() / 4);
        } 
        else 
        {
            imageFill = (forcefield.getAlpha() * 2);
        }
        img.fillRect(0, 0, imageFill, imageY);
        setImage(img);
    }

    private Color MyColor()
    {
        return new Color(r,g,b,alpha);
    }
}