import greenfoot.*;
import java.awt.Color;
import java.util.List;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Space here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Space extends World
{
    private Starship Endeavour;
    private Forcefield forcefield;
    private Boss Khan;
    int enemiesKilled = 0;
    int enemiesPerRound = 20;
    int enemiesOnScreen = 0;
    int enemiesRemaining;
    int enemiesCreated = 0;
    int roundCount = 0;

    public Space()
    {    
        super(500, 600, 1, false);
        GreenfootImage background = getBackground();
        background.setColor(Color.BLACK);
        background.fill();
        Endeavour = new Starship(270);
        forcefield = new Forcefield();
        addObject(Endeavour, getWidth() / 2, getHeight() - (getHeight() /4));
        addObject(forcefield, getWidth() / 2, getHeight() - (getHeight() / 4));
        addObject(new StarshipBar(180), 99, 584);
        addObject(new ForcefieldBar(0), 400, 585);
        addObject(new WeaponBar(180), 249, 584);
        for (int i=0; i < 75; i++)  
        {  
            int x = Greenfoot.getRandomNumber(getWidth()+100)-50;  
            int y = Greenfoot.getRandomNumber(getHeight()+100)-50;  
            addObject(new Star(), x, y);  
        }
    }

    public void act()
    {
        enemiesRemaining = enemiesPerRound - enemiesCreated;
        if (enemiesOnScreen < 3 && Endeavour.getHealth() > 0 && enemiesRemaining > 1)
        {
            int enemyPick = Greenfoot.getRandomNumber(2);
            int x = Greenfoot.getRandomNumber(getWidth());  
            int y = -100;  
            if (enemyPick == 0)
            {
                addObject(new Kamikaze(), x, y);
            }
            if (enemyPick == 1)
            {
                addObject(new Sniper(), x, y);
            }
            enemiesOnScreen++;
            enemiesCreated++;
            removeObjects(getObjects(Text.class));
            addObject(new Text("Enemies remaining: " + enemiesRemaining, 22, Color.WHITE, null), 80, 10);
        } 
        if (enemiesRemaining == 1 && enemiesOnScreen == 0)
        {
            Khan = new Boss();
            addObject(Khan, 250, -100);
            enemiesOnScreen++;
            enemiesCreated++;
        }
    } 

    public Starship getStarship()
    {
        return Endeavour;
    }

    public Boss getBoss()
    {
        return Khan;
    }

    public Forcefield getForcefield()
    {
        return forcefield;
    }
}
