import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Rocket here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Starship extends Actor
{
    int health = 100;
    int weaponFireDelay = 0;
    int repair = 0;

    public Starship(int rotation)
    {
        setRotation(rotation);
    }

    public void act() 
    {
        checkKeys();
        moveStars();
        checkHit();
        weaponFireDelay++;
    }

    public void checkKeys()
    {
        if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a"))
        {
            turn(-3);
        }
        if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d"))
        {
            turn(3);
        }
        if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w"))
        {
            move(3);
        }
        if (Greenfoot.isKeyDown("space") && weaponFireDelay >= 60)
        {
            ShipLaser shipLaser = new ShipLaser(getRotation());
            getWorld().addObject(shipLaser, getX(), getY());
            shipLaser.move(getImage().getHeight() / 2 + shipLaser.getImage().getWidth() / 2);
            Greenfoot.playSound("Beam.wav");
            weaponFireDelay = 0;
        }
    }

    public void moveStars()
    {
        for (Object obj : getWorld().getObjects(Star.class))  
        {  
            Star star = (Star) obj;  
            star.move(getRotation());  
        } 
    }

    public void checkHit()
    {
        Space mySpace = (Space) getWorld();
        Forcefield forcefield = mySpace.getForcefield();
        Actor laser = getOneIntersectingObject(FoeLaser.class);
        Actor beam = getOneIntersectingObject(Beam.class);
        if (forcefield.getAlpha() <= 0 && laser != null)
        {
            health = health - 25;
            getWorld().removeObject(laser);
        }
        if (beam != null)
        {
            health = health - 25;
            getWorld().removeObject(beam);
        }
        if (health != 100)
        {
            repair++;
            if (repair == 40)
            {
                health++;
                repair = 0;
            }
        }
        if (health <= 0)
        {
            getWorld().addObject(new Explosion(), getX(), getY());
            getWorld().addObject(new Gameover(), 250, 300);
            getWorld().removeObject(this);
        }
    }

    public int getHealth()
    {
        return health;
    }

    public int getWeaponDelay()
    {
        return weaponFireDelay;
    }
}
